clc;
clear;

m = [32 16 8 4 2]; %input('Node Numbers for Each Layer: ');
h = length(m) - 2; % number of hidden layers
nx = m(1); % number of input nodes
ny = m(h+2); % Number of Classes

mu = [1 -1];%input('Means for Each Class: ');
assert(length(mu)==ny);
sigma = [4 4];%input('Standard Deviations for Each Class: ');
assert(length(sigma)==ny);

nts = 100;%input('Number of Training Samples: ');
sample = randn(ny, nts, nx);% training samples
for c=1:ny% for each class
    sample(c,:,:) = mu(c) + sigma(c)*sample(c,:,:);
end
% hb = max(max(max(sample)));
% lb = min(min(min(sample)));
% sample = (sample-lb)/(hb-lb);

w = rand(h+1, max(m), max(m));% all weights
b = rand(h+1, max(m));
for l=1:(h+1)
    w(l, ((m(l)+1):max(m)), :) = 0;
    w(l, :, ((m(l+1)+1):max(m))) = 0;
    b(l, ((m(l+1)+1):max(m))) = 0;
end

eta = 1;%input('Learning Rate: ');

%%
% x = sample;
% tic;
% for l=1:h
%     wl = rand(m(l), m(l+1));
%     bl = rand(1, m(l+1));
%     for c=1:ny
%         for its=1:nts
%             xl = reshape(x(c,its,:), [1,m(l)]);
%             [wl, bl] = autoencode(xl, wl, bl, eta);
%         end
%     end
%     w(l, 1:m(l), 1:m(l+1)) = wl;
%     b(l, 1:m(l+1)) = bl;
%     
%     z = zeros(ny, nts, m(l+1));
%     for c=1:ny
%         for its=1:nts
%             xl = reshape(x(c,its,:), [1,m(l)]);            
%             zl = zeros(1, m(l+1));
%             for j=1:m(l+1)
%                 zl(j) = sum(xl.*wl(:,j)') + bl(j);
%                 zl(j) = 1/(1+exp(-zl(j)));
%             end
%             z(c,its,:) = zl;
%         end
%     end
%     x = z;
% end
% toc;
%%


z = zeros(h+2, max(m));% all nodes
% training
tic;
for its=1:nts% for each training sample
    for c=1:ny% for each class
        t = zeros(1,ny);
        t(c) = 1;% target output vector
        x = reshape(sample(c,its,:), [1,nx]);
        z(1,(1:nx)) = x;
        while 1
            z = encode(z, w, b, m);
            y = z(h+2,(1:ny));% actual output
            if mse(y-t)<1e-1
                break;
            end
            [dw, db] = bp(z, w, m, y, t);
            w = w - eta*dw;
            b = b - eta*db;
        end
    end
end
toc;

% test
nerrs = 0;
for i=1:1000
    c = (rand(1)<0.5)+1;
    x = mu(c) + sigma(c)*randn(1,nx);
    z(1,(1:nx)) = x;
    z = encode(z, w, b, m);
    y = z(h+2,(1:ny));% actual output
    [a,rc] = max(y);
    if c~=rc
        nerrs = nerrs+1;
    end
end
disp(nerrs/1000);